diff --git a/media/js/featurematrix.js b/media/js/featurematrix.js
index 13dd183..1d8657b 100644
--- a/media/js/featurematrix.js
+++ b/media/js/featurematrix.js
@@ -2,6 +2,7 @@
  * Filter feature matrix
  */
 $(document).ready(function(){
+
     // Show/hide column based on whether supplied checkbox is checked.
     function filter_version(checkbox)
     {
@@ -35,19 +36,56 @@ $(document).ready(function(){
         });
     }
 
-    // Upon loading the page, apply the filter based on EOL versions that are
-    // unchecked.
-    $('form#featurematrix_version_filter input.featurematrix_version').not(':checked').each(function(){
-        filter_version($(this));
-    });
+    function update_url_from_checkboxes()
+    {
+	// gather state from the checkboxes
+	var hashstr = '';
+        var hide_unchanged=$('form#featurematrix_version_filter input#hide_unchanged').is(':checked');
+	if (hide_unchanged) { hashstr += "&huf=1"; }
+	var vstr = $('form#featurematrix_version_filter input.featurematrix_version:checked').map(
+	    function(el) { return this.id.replace("toggle_",""); }).get().join();
+	if (vstr != '') {
+	    hashstr += '&v='+vstr;
+	}
+	window.location.hash = hashstr.replace(/^&+/, '');
+    }
+    var non_eol_versions = $('form#featurematrix_version_filter input.featurematrix_version:checked').map(
+	function(el) { return this.id.replace("toggle_",""); }).get().join();
+    function update_checkboxes_from_url(first)
+    {
+	// gather state from the checkboxes
+	var huf= ( window.location.hash.match(/[#&]huf=1/) != null );
+	$('form#featurematrix_version_filter input#hide_unchanged').prop('checked', huf);
+	var vmatch = window.location.hash.match(/[#&]v=([^&]+)/) || ["", non_eol_versions];
+	$('form#featurematrix_version_filter input.featurematrix_version').each(function() {
+	    var newstate = (vmatch[1].match(this.id.replace('toggle_','')) != null);
+	    if ($(this).prop('checked') != newstate) {  // much faster
+		$(this).prop('checked', newstate);
+		filter_version($(this));
+	    }
+	});
+	if (first) {
+	    $('form#featurematrix_version_filter input.featurematrix_version').each(function() {
+		filter_version($(this));
+	    });
+	}
+	// must run this last
+	hide_unchanged();
+    }
+
+    // Upon loading the page, apply the filter based on EOL versions that are unchecked.
+    update_checkboxes_from_url(true);
 
     // Apply filter based on change in check status of clicked version filter.
     $('form#featurematrix_version_filter input.featurematrix_version').on("change", function(){
         filter_version($(this));
+	update_url_from_checkboxes(false);
     });
 
     // Show/hide unchanged feature rows when checkbox clicked.
     $('form#featurematrix_version_filter input#hide_unchanged').on("change", function(){
         hide_unchanged();
+	update_url_from_checkboxes(false);
     });
+
 });
